#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>

static long long millitime(void) {
        struct timeval n;
        gettimeofday(&n,0);
        return (n.tv_sec *1000 + n.tv_usec/1000);
}


int out[1024];

char in[1024] = "ϥѥꤷʤȡʬͽ¬ΥҥåΨ
	⤯ʤꤹ 128ХȰʾʤʤǤ⤤餳ʸˤޤ";

#define COLOR_TRANSPARENT	0x30

#define LOOP_COUNT	10000
main(int argc,char *argv[]) {
	char *p;
	int pen_color = argc;
	int i,j,k;
	int *bp;
	long long s,e;
	int dps;
	int type;
	unsigned char pat[256][8];
	unsigned char *pp = &pat[0][0];
	for( j = 0; j < 256; j++ )
	{
	  *pp++ = (j >> 7) & 1;
	  *pp++ = (j >> 6) & 1;
	  *pp++ = (j >> 5) & 1;
	  *pp++ = (j >> 4) & 1;
	  *pp++ = (j >> 3) & 1;
	  *pp++ = (j >> 2) & 1;
	  *pp++ = (j >> 1) & 1;
	  *pp++ = (j >> 0) & 1;
	}

	for (type=0; type < 5; type++) {
	  s = millitime();
	  for (i=0; i< LOOP_COUNT; i++) {
	     bp = out;
	     p = in;
	     /* original */
	     if (type == 0) {
	       for (j=0; j<128; j++) {
                    for (k = 0; k < 8; k++) {
                        *bp++ = (*p & (1<<(7-k)))? pen_color
                                          :COLOR_TRANSPARENT;
                    }
	            p++;
	        }
	     }
	     /* optimize for 486 */
	     else if (type == 1) {
	       for (j=0; j<128; j++) {
		  int mask = *p++;
		  bp[0] = (mask & (1<<(7-0)))? pen_color :COLOR_TRANSPARENT;
		  bp[1] = (mask & (1<<(7-1)))? pen_color :COLOR_TRANSPARENT;
		  bp[2] = (mask & (1<<(7-2)))? pen_color :COLOR_TRANSPARENT;
		  bp[3] = (mask & (1<<(7-3)))? pen_color :COLOR_TRANSPARENT;
		  bp[4] = (mask & (1<<(7-4)))? pen_color :COLOR_TRANSPARENT;
		  bp[5] = (mask & (1<<(7-5)))? pen_color :COLOR_TRANSPARENT;
		  bp[6] = (mask & (1<<(7-6)))? pen_color :COLOR_TRANSPARENT;
		  bp[7] = (mask & (1<<(7-7)))? pen_color :COLOR_TRANSPARENT;
		  bp += 8;
	        }
	     }
	     /* optimaize for mips */
	     else if (type == 2) {
	       for (j=0; j<128; j++) {
		  int mask = *p++;
		  bp[0] = COLOR_TRANSPARENT;
		  if (mask & (1<<7)) bp[0] = pen_color;
		  bp[1] = COLOR_TRANSPARENT;
		  if (mask & (1<<6)) bp[1] = pen_color;
		  bp[2] = COLOR_TRANSPARENT;
		  if (mask & (1<<5)) bp[2] = pen_color;
		  bp[3] = COLOR_TRANSPARENT;
		  if (mask & (1<<4)) bp[3] = pen_color;
		  bp[4] = COLOR_TRANSPARENT;
		  if (mask & (1<<3)) bp[4] = pen_color;
		  bp[5] = COLOR_TRANSPARENT;
		  if (mask & (1<<2)) bp[5] = pen_color;
		  bp[6] = COLOR_TRANSPARENT;
		  if (mask & (1<<1)) bp[6] = pen_color;
		  bp[7] = COLOR_TRANSPARENT;
		  if (mask & (1<<0)) bp[7] = pen_color;
		  bp += 8;
	        }
	     }
	    /* optimize for arm */
	     else if (type == 3) {
	       for (j=0; j<128; j++) {
		  int mask = (*p++) << 24;
		  bp[0] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[0] = pen_color;
		  bp[1] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[1] = pen_color;
		  bp[2] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[2] = pen_color;
		  bp[3] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[3] = pen_color;
		  bp[4] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[4] = pen_color;
		  bp[5] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[5] = pen_color;
		  bp[6] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[6] = pen_color;
		  bp[7] = COLOR_TRANSPARENT;
		  if((mask <<= 1) < 0) bp[7] = pen_color;
		  bp += 8;
	       }
	     }
	     else if (type == 4) {
	       unsigned char *ucp = (unsigned char *)p;
	       int pcolor[2];
	       pcolor[0] = COLOR_TRANSPARENT;
	       pcolor[1] = pen_color;
	       for (j=0; j<128; j++) {
		 unsigned char *pp = &pat[*ucp++][0];
		 bp[0] = pcolor[pp[0]];
		 bp[1] = pcolor[pp[1]];
		 bp[2] = pcolor[pp[2]];
		 bp[3] = pcolor[pp[3]];
		 bp[4] = pcolor[pp[4]];
		 bp[5] = pcolor[pp[5]];
		 bp[6] = pcolor[pp[6]];
		 bp[7] = pcolor[pp[7]];
		 bp += 8;
	        }
	     }
	     strncpy((char *)out,"",0); /* Ŭ줹ʤ褦   */
	     strncpy(in,"",0);	        /* ȥå 		      */
	  }
	  e = millitime();

	  if (e == s) {
		printf("error\n");
	  } else {
	    dps = LOOP_COUNT * 128 * 8/(int)(e - s);
	    printf("type%d: %d k dot/sec\n",type,dps);
	  }
	}
}
